Index: /LMDZ4/trunk/libf/phylmd/read_pstoke0.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/read_pstoke0.F	(revision 540)
+++ /LMDZ4/trunk/libf/phylmd/read_pstoke0.F	(revision 541)
@@ -7,5 +7,13 @@
      .   zrec,zkon,zkev,airefi,phisfi,
      .   t,mfu,mfd,en_u,de_u,en_d,de_d,coefh,
+     .   fm_therm,en_therm,
      .   frac_impa,frac_nucl,pyu1,pyv1,ftsol,psrf)
+
+C******************************************************************************
+C  Frederic HOURDIN, Abderrahmane IDELKADI
+C Lecture des parametres physique stockes online necessaires pour
+C recalculer offline le transport des traceurs sur la meme grille que online
+C A FAIRE : une seule routine au lieu de 2 (lectflux, redecoupe)!
+C******************************************************************************
 
 
@@ -26,29 +34,36 @@
 #include "dimphy.h"
 	  
-	  integer*4 kon,kev,zkon,zkev
+	  integer kon,kev,zkon,zkev
 	  parameter(kon=iim*(jjm-1)+2,kev=llm)
-	  REAL*4 phisfi(kon)
-          REAL*4 phisfi2(iim,jjm+1),airefi2(iim,jjm+1)
-
-          REAL*4 mfu(kon,kev), mfd(kon,kev)
-          REAL*4 en_u(kon,kev), de_u(kon,kev)
-          REAL*4 en_d(kon,kev), de_d(kon,kev)
-          REAL*4 coefh(kon,kev)
-		REAL*4 t(kon,kev)
-
-          REAL*4 mfu2(iim,jjm+1,kev), mfd2(iim,jjm+1,kev)
-          REAL*4 en_u2(iim,jjm+1,kev), de_u2(iim,jjm+1,kev)
-          REAL*4 en_d2(iim,jjm+1,kev), de_d2(iim,jjm+1,kev)
-          REAL*4 coefh2(iim,jjm+1,kev)
-		REAL*4 t2(iim,jjm+1,kev)
-
-          REAL*4 pl(kev)
+	  REAL phisfi(kon)
+          REAL phisfi2(iim,jjm+1),airefi2(iim,jjm+1)
+
+          REAL mfu(kon,kev), mfd(kon,kev)
+          REAL en_u(kon,kev), de_u(kon,kev)
+          REAL en_d(kon,kev), de_d(kon,kev)
+          REAL coefh(kon,kev)
+
+c abd 25 11 02
+c Thermiques
+	 REAL fm_therm(kon,kev),en_therm(kon,kev)
+		REAL t(kon,kev)
+
+          REAL mfu2(iim,jjm+1,kev), mfd2(iim,jjm+1,kev)
+          REAL en_u2(iim,jjm+1,kev), de_u2(iim,jjm+1,kev)
+          REAL en_d2(iim,jjm+1,kev), de_d2(iim,jjm+1,kev)
+          REAL coefh2(iim,jjm+1,kev)
+		REAL t2(iim,jjm+1,kev)
+c Thermiques
+	 REAL fm_therm2(iim,jjm+1,kev)
+         REAL en_therm2(iim,jjm+1,kev)       
+
+          REAL pl(kev)
           integer irec
-          integer*4 xid,yid,zid,tid
-          integer*4 zrec,zim,zjm
-          integer*4 ncrec,nckon,nckev,ncim,ncjm
-
-          real*4 airefi(kon)
-          character namedim
+          integer xid,yid,zid,tid
+          integer zrec,zim,zjm
+          integer ncrec,nckon,nckev,ncim,ncjm
+
+          real airefi(kon)
+          character*20 namedim
 
 c  !! attention !!
@@ -56,17 +71,17 @@
 c dim de phis??
 
-          REAL*4 frac_impa(kon,kev), frac_nucl(kon,kev)
-          REAL*4 frac_impa2(iim,jjm+1,kev), 
+          REAL frac_impa(kon,kev), frac_nucl(kon,kev)
+          REAL frac_impa2(iim,jjm+1,kev), 
      .     frac_nucl2(iim,jjm+1,kev)
-          REAL*4 pyu1(kon), pyv1(kon)
-          REAL*4 pyu12(iim,jjm+1), pyv12(iim,jjm+1)
-          REAL*4 ftsol(kon,nbsrf)
-          REAL*4 psrf(kon,nbsrf) 
-	  REAL*4 ftsol1(kon),ftsol2(kon),ftsol3(kon),ftsol4(kon)
-          REAL*4 psrf1(kon),psrf2(kon),psrf3(kon),psrf4(kon)
-          REAL*4 ftsol12(iim,jjm+1),ftsol22(iim,jjm+1),
+          REAL pyu1(kon), pyv1(kon)
+          REAL pyu12(iim,jjm+1), pyv12(iim,jjm+1)
+          REAL ftsol(kon,nbsrf)
+          REAL psrf(kon,nbsrf) 
+	  REAL ftsol1(kon),ftsol2(kon),ftsol3(kon),ftsol4(kon)
+          REAL psrf1(kon),psrf2(kon),psrf3(kon),psrf4(kon)
+          REAL ftsol12(iim,jjm+1),ftsol22(iim,jjm+1),
      .     ftsol32(iim,jjm+1),
      .     ftsol42(iim,jjm+1)
-          REAL*4 psrf12(iim,jjm+1),psrf22(iim,jjm+1),psrf32(iim,jjm+1),
+          REAL psrf12(iim,jjm+1),psrf22(iim,jjm+1),psrf32(iim,jjm+1),
      .     psrf42(iim,jjm+1)
 	
@@ -76,4 +91,6 @@
 		integer varidt
           integer varidend,varidded,varidch,varidfi,varidfn
+c therm
+	  integer varidfmth,varidenth
           integer varidyu1,varidyv1,varidpl,varidai,varididvt
           integer varidfts1,varidfts2,varidfts3,varidfts4
@@ -82,4 +99,6 @@
 		save varidt
           save varidend,varidded,varidch,varidfi,varidfn
+c therm
+	   save varidfmth,varidenth
           save varidyu1,varidyv1,varidpl,varidai,varididvt
           save varidfts1,varidfts2,varidfts3,varidfts4
@@ -112,10 +131,10 @@
             print*,'ncidp,varidai',ncidp,varidai
 
+                varidt=NCVID(ncidp,'t',rcode)
+                print*,'ncidp,varidt',ncidp,varidt
+
             varidmfu=NCVID(ncidp,'mfu',rcode)
             print*,'ncidp,varidmfu',ncidp,varidmfu
 
-		varidt=NCVID(ncidp,'t',rcode)
-                print*,'ncidp,varidt',ncidp,varidt
-
             varidmfd=NCVID(ncidp,'mfd',rcode)
             print*,'ncidp,varidmfd',ncidp,varidmfd
@@ -135,4 +154,11 @@
             varidch=NCVID(ncidp,'coefh',rcode)
             print*,'ncidp,varidch',ncidp,varidch
+
+c Thermiques
+            varidfmth=NCVID(ncidp,'fm_th',rcode)
+            print*,'ncidp,varidfmth',ncidp,varidfmth
+
+            varidenth=NCVID(ncidp,'en_th',rcode)
+            print*,'ncidp,varidenth',ncidp,varidenth
 	
 	    varidfi=NCVID(ncidp,'frac_impa',rcode)
@@ -216,10 +242,20 @@
 
 c 
+C**** Geopotentiel au sol ***************************************
 c phis
-      status=NF_GET_VARA_REAL(ncidp,varidps,start,count,phisfi2)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidps,start,count,phisfi2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidps,start,count,phisfi2)
+#endif
       call gr_ecrit_fi(1,kon,iim,jjm+1,phisfi2,phisfi)
 
+C**** Aires des mails aux sol ************************************
 c aire
-      status=NF_GET_VARA_REAL(ncidp,varidai,start,count,airefi2)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidai,start,count,airefi2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidai,start,count,airefi2)
+#endif
       call gr_ecrit_fi(1,kon,iim,jjm+1,airefi2,airefi)
       else
@@ -244,46 +280,116 @@
       count(4)=1
 
-c frac_impa 
-
-      status=NF_GET_VARA_REAL(ncidp,varidfi,start,count,frac_impa2)
-      call gr_ecrit_fi(kev,kon,iim,jjm+1,frac_impa2,frac_impa)
-
-c frac_nucl 
-
-      status=NF_GET_VARA_REAL(ncidp,varidfn,start,count,frac_nucl2)
-      call gr_ecrit_fi(kev,kon,iim,jjm+1,frac_nucl2,frac_nucl)
+C**** Temperature ********************************************
+cA FAIRE : Es-ce necessaire ?
 
 c abder t
-      status=NF_GET_VARA_REAL(ncidp,varidt,start,count,t2)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidt,start,count,t2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidt,start,count,t2)
+#endif
       call gr_ecrit_fi(kev,kon,iim,jjm+1,t2,t)
 
+C**** Flux pour la convection (Tiedtk) ********************************************
 c mfu
-      status=NF_GET_VARA_REAL(ncidp,varidmfu,start,count,mfu2)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidmfu,start,count,mfu2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidmfu,start,count,mfu2)
+#endif
       call gr_ecrit_fi(kev,kon,iim,jjm+1,mfu2,mfu)
 
 c mfd
-      status=NF_GET_VARA_REAL(ncidp,varidmfd,start,count,mfd2)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidmfd,start,count,mfd2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidmfd,start,count,mfd2)
+#endif
       call gr_ecrit_fi(kev,kon,iim,jjm+1,mfd2,mfd)
 
 c en_u 
-      status=NF_GET_VARA_REAL(ncidp,varidenu,start,count,en_u2)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidenu,start,count,en_u2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidenu,start,count,en_u2)
+#endif
       call gr_ecrit_fi(kev,kon,iim,jjm+1,en_u2,en_u)
 
 c de_u 
-      status=NF_GET_VARA_REAL(ncidp,variddeu,start,count,de_u2)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,variddeu,start,count,de_u2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,variddeu,start,count,de_u2)
+#endif
       call gr_ecrit_fi(kev,kon,iim,jjm+1,de_u2,de_u)
 
 c en_d 
-      status=NF_GET_VARA_REAL(ncidp,varidend,start,count,en_d2)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidend,start,count,en_d2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidend,start,count,en_d2)
+#endif
       call gr_ecrit_fi(kev,kon,iim,jjm+1,en_d2,en_d)
 
 c de_d 
-      status=NF_GET_VARA_REAL(ncidp,varidded,start,count,de_d2)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidded,start,count,de_d2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidded,start,count,de_d2)
+#endif
       call gr_ecrit_fi(kev,kon,iim,jjm+1,de_d2,de_d)
 
+C**** Coefficient de mellange turbulent *******************************************
 c coefh 
 	print*,'LECTURE de coefh a irec =',irec
-       status=NF_GET_VARA_REAL(ncidp,varidch,start,count,coefh2)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidch,start,count,coefh2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidch,start,count,coefh2)
+#endif
        call gr_ecrit_fi(kev,kon,iim,jjm+1,coefh2,coefh)
+c      call dump2d(iip1,jjp1,coefh2(1,2),'COEFH2READ   ')
+c      call dump2d(iim ,jjm ,coefh (2,2),'COEFH2READ   ')
+
+C**** Flux ascendants et entrant dans le thermique **********************************
+cThermiques
+       print*,'LECTURE de fm_therm a irec =',irec
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfmth,start,
+     .                         count,fm_therm2)
+#else
+       status=NF_GET_VARA_REAL(ncidp,varidfmth,start,
+     .                         count,fm_therm2)
+#endif
+       call gr_ecrit_fi(kev,kon,iim,jjm+1,fm_therm2,fm_therm)
+       print*,'LECTURE de en_therm a irec =',irec
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidenth,start,
+     .                          count,en_therm2)
+#else
+       status=NF_GET_VARA_REAL(ncidp,varidenth,start,
+     .                          count,en_therm2)
+#endif
+       call gr_ecrit_fi(kev,kon,iim,jjm+1,en_therm2,en_therm)
+
+C**** Coefficients de lessivage *******************************************
+c frac_impa
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfi,start,count,frac_impa2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidfi,start,count,frac_impa2)
+#endif
+      call gr_ecrit_fi(kev,kon,iim,jjm+1,frac_impa2,frac_impa)
+
+c frac_nucl
+
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfn,start,count,frac_nucl2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidfn,start,count,frac_nucl2)
+#endif
+      call gr_ecrit_fi(kev,kon,iim,jjm+1,frac_nucl2,frac_nucl)
+
+C**** Vents aux sol ********************************************
 
       start(3)=irec
@@ -294,47 +400,89 @@
 c pyu1
 	print*,'LECTURE de yu1 a irec =',irec
-      status=NF_GET_VARA_REAL(ncidp,varidyu1,start,count,pyu12)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidyu1,start,count,pyu12)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidyu1,start,count,pyu12)
+#endif
       call gr_ecrit_fi(1,kon,iim,jjm+1,pyu12,pyu1)
 
 c pyv1
         print*,'LECTURE de yv1 a irec =',irec
-      status=NF_GET_VARA_REAL(ncidp,varidyv1,start,count,pyv12)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidyv1,start,count,pyv12)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidyv1,start,count,pyv12)
+#endif
       call gr_ecrit_fi(1,kon,iim,jjm+1,pyv12,pyv1)
 
+C**** Temerature au sol ********************************************
 c ftsol1
         print*,'LECTURE de ftsol1 a irec =',irec
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfts1,start,count,ftsol12)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidfts1,start,count,ftsol12)
+#endif
        call gr_ecrit_fi(1,kon,iim,jjm+1,ftsol12,ftsol1)
 
 c ftsol2
         print*,'LECTURE de ftsol2 a irec =',irec
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfts2,start,count,ftsol22)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidfts2,start,count,ftsol22)
+#endif
       call gr_ecrit_fi(1,kon,iim,jjm+1,ftsol22,ftsol2)
 
 c ftsol3
 	 print*,'LECTURE de ftsol3 a irec =',irec
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfts3,start,count,ftsol32)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidfts3,start,count,ftsol32)
+#endif
       call gr_ecrit_fi(1,kon,iim,jjm+1,ftsol32,ftsol3)
 
 c ftsol4
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfts4,start,count,ftsol42)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidfts4,start,count,ftsol42)
+#endif
       call gr_ecrit_fi(1,kon,iim,jjm+1,ftsol42,ftsol4)
 
+C**** Nature sol ********************************************
 c psrf1 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidpsr1,start,count,psrf12)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidpsr1,start,count,psrf12)
+#endif
 c      call dump2d(iip1-1,jjm+1,psrf12,'PSRF1NC')
       call gr_ecrit_fi(1,kon,iim,jjm+1,psrf12,psrf1)
 
 c psrf2 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidpsr2,start,count,psrf22)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidpsr2,start,count,psrf22)
+#endif
 c      call dump2d(iip1-1,jjm+1,psrf22,'PSRF2NC')
       call gr_ecrit_fi(1,kon,iim,jjm+1,psrf22,psrf2)
 
 c psrf3 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidpsr3,start,count,psrf32)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidpsr3,start,count,psrf32)
+#endif
       call gr_ecrit_fi(1,kon,iim,jjm+1,psrf32,psrf3)
 
 c psrf4 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidpsr4,start,count,psrf42)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidpsr4,start,count,psrf42)
+#endif
       call gr_ecrit_fi(1,kon,iim,jjm+1,psrf42,psrf4)
 	
@@ -344,4 +492,6 @@
         psrf(i,2) = psrf2(i)
         psrf(i,3) = psrf3(i)
+c test abderr
+c	print*,'Dans read_pstoke psrf3 =',psrf3(i),i
         psrf(i,4) = psrf4(i)
   
Index: /LMDZ4/trunk/libf/phylmd/ustarhb.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/ustarhb.F	(revision 541)
+++ /LMDZ4/trunk/libf/phylmd/ustarhb.F	(revision 541)
@@ -0,0 +1,53 @@
+!
+! $Header$
+!
+      SUBROUTINE ustarhb(knon,u,v,cd_m, ustar)
+      IMPLICIT none
+c======================================================================
+c Laurent Li (LMD/CNRS), le 30 septembre 1998
+c Couche limite non-locale. Adaptation du code du CCM3.
+c Code non teste, donc a ne pas utiliser.
+c======================================================================
+c Nonlocal scheme that determines eddy diffusivities based on a
+c diagnosed boundary layer height and a turbulent velocity scale.
+c Also countergradient effects for heat and moisture are included.
+c
+c For more information, see Holtslag, A.A.M., and B.A. Boville, 1993:
+c Local versus nonlocal boundary-layer diffusion in a global climate
+c model. J. of Climate, vol. 6, 1825-1842.
+c======================================================================
+#include "dimensions.h"
+#include "dimphy.h"
+#include "YOMCST.h"
+c
+c Arguments:
+c
+      INTEGER knon ! nombre de points a calculer
+      REAL u(klon,klev) ! vitesse U (m/s)
+      REAL v(klon,klev) ! vitesse V (m/s)
+      REAL cd_m(klon) ! coefficient de friction au sol pour vitesse
+      REAL ustar(klon)
+c
+      INTEGER i, k
+      REAL zxt, zxq, zxu, zxv, zxmod, taux, tauy
+      REAL zx_alf1, zx_alf2 ! parametres pour extrapolation
+      LOGICAL unssrf(klon)  ! unstb pbl w/lvls within srf pbl lyr
+      LOGICAL unsout(klon)  ! unstb pbl w/lvls in outer pbl lyr
+      LOGICAL check(klon)   ! True=>chk if Richardson no.>critcal
+c
+#include "YOETHF.h"
+#include "FCTTRE.h"
+      DO i = 1, knon
+        zx_alf1 = 1.0
+        zx_alf2 = 1.0 - zx_alf1
+        zxu = u(i,1)*zx_alf1+u(i,2)*zx_alf2
+        zxv = v(i,1)*zx_alf1+v(i,2)*zx_alf2
+        zxmod = 1.0+SQRT(zxu**2+zxv**2)
+        taux = zxu *zxmod*cd_m(i)
+        tauy = zxv *zxmod*cd_m(i)
+        ustar(i) = SQRT(taux**2+tauy**2)
+c       print*,'Ust ',zxu,zxmod,taux,ustar(i)
+      ENDDO
+c
+      return
+      end
